"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var grommet_1 = require("grommet");
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var utils_1 = require("../../utils");
var getBorderColor = function (props) {
    if (props.invalid) {
        return props.theme.colors.danger.main;
    }
    if (props.valid) {
        return props.theme.colors.success.main;
    }
};
var StyledGrommetTextArea = styled_components_1.default(grommet_1.TextArea)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t", ";\n\n\tpadding: 14px 20px;\n\tcolor: ", ";\n\tcursor: ", ";\n\tborder-color: ", ";\n\n\tresize: vertical;\n\tdisplay: block;\n\twidth: 100%;\n\n\t&:focus {\n\t\tborder-color: ", ";\n\t}\n"], ["\n\t", ";\n\n\tpadding: 14px 20px;\n\tcolor: ", ";\n\tcursor: ", ";\n\tborder-color: ", ";\n\n\tresize: vertical;\n\tdisplay: block;\n\twidth: 100%;\n\n\t&:focus {\n\t\tborder-color: ", ";\n\t}\n"])), utils_1.monospace, function (props) { return props.theme.colors.text.main; }, function (props) { return (props.disabled ? 'not-allowed' : 'auto'); }, getBorderColor, function (props) { return props.theme.colors.tertiary.main; });
var Component = function (_a) {
    var autoRows = _a.autoRows, maxRows = _a.maxRows, minRows = _a.minRows, rows = _a.rows, props = __rest(_a, ["autoRows", "maxRows", "minRows", "rows"]);
    var rowsProp = rows;
    if (autoRows && props.onChange) {
        rowsProp = (props.value || '').split('\n').length;
    }
    if (maxRows && (rowsProp || 0) > maxRows) {
        rowsProp = maxRows;
    }
    if (minRows && (rowsProp || 0) < minRows) {
        rowsProp = minRows;
    }
    return React.createElement(StyledGrommetTextArea, __assign({ rows: rowsProp }, props));
};
exports.default = asRendition_1.default(Component);
var templateObject_1;
